package com.caimei365.manager.service.caimei.providers;

import com.caimei365.manager.entity.PaginationVo;
import com.caimei365.manager.entity.ResponseJson;
import com.caimei365.manager.entity.caimei.cmUser.CmClub;
import com.caimei365.manager.entity.caimei.providers.ServiceProviderModel;
import com.caimei365.manager.entity.caimei.product.Product;
import com.caimei365.manager.entity.caimei.providers.CmProviderTeam;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * Service接口
 *
 * @author Kaick
 * @date 2023-12-12
 */
public interface CmProvidersService {
    /**
     * 通过对象查询列表
     *
     * @param cmProviders
     * @return 集合
     */
    List<ServiceProviderModel> getCmProvidersList(ServiceProviderModel cmProviders);

    /**
     * 通过Id查询
     *
     * @param id 主键
     * @return
     */
    ServiceProviderModel getCmProvidersById(Integer id);

    /**
     * 通过对象查询
     *
     * @param cmProviders
     * @return
     */
    ServiceProviderModel getByCmProviders(ServiceProviderModel cmProviders);


    /**
     * 新增
     *
     * @param cmProviders
     * @return 结果
     */
    int addCmProviders(ServiceProviderModel cmProviders);

    /**
     * 修改
     *
     * @param cmProviders
     * @return 结果
     */
    int updateCmProviders(ServiceProviderModel cmProviders);

    /**
     * 下載圖片
     */
    void downloadImage(String ids, Integer type, HttpServletRequest request, HttpServletResponse response) throws Exception;


    ResponseJson<PaginationVo<Product>> getProviderProducts(Integer providerId, String shopName, String productName, Integer productId, Integer shopId, int pageNum, int pageSize);

    ResponseJson addProvidersProducts(Integer providerId, String productIds);

    ResponseJson<PaginationVo<Product>> getProviderProductList(Integer providerId, String productName, Integer productId, int pageNum, int pageSize);

    ResponseJson delProvidersProducts(Integer providerId, Integer productId);

    ResponseJson updatePassWord(Integer userId, String password);

    ResponseJson<PaginationVo<CmProviderTeam>> providerTeam(int pageNum, int pageSize);

    ResponseJson<PaginationVo<CmClub>> clubList(Integer spId, Integer clubId, String name, String linkMan, String bindMobile, int pageNum, int pageSize);

    ResponseJson addTeam(CmProviderTeam team);

    ResponseJson delTeam(Integer id);

    ResponseJson<PaginationVo<ServiceProviderModel>> groupList(Integer id, int pageNum, int pageSize);

    ResponseJson delGroup(Integer teamId, Integer spId);

    ResponseJson addGroup(Integer teamId, String spId);

    ResponseJson<PaginationVo<ServiceProviderModel>> addGroups(String mobile, String name, int pageNum, int pageSize);

    ResponseJson updateLeader(CmProviderTeam team);
}



